'''
Created on Sep 15, 2015

@author: scrosby
'''
from gus.stats.HistoryStats import HistoryStats

class CycleTime(HistoryStats):

    def __init__(self, history):
        self.real_start = None
        HistoryStats.__init__(self, history)
        
    def calculate_cycle_time(self):
        return self.__hour_delta__(self.get_work_start_time(), self.get_work_closed_time())
    
    def calculate_dev_cycle_time(self):
        return self.__hour_delta__(self.get_work_start_time(), self.get_last_fixed_time())
    
    def calculate_qe_cycle_time(self):
        return self.__hour_delta__(self.get_first_qe_start_time(), self.get_work_closed_time())
    

    def get_work_start_time(self):
        out = None
        if self.real_start:
            out = self.real_start
        else:
            out = self.__first_value_time__('In Progress')

        if not out and len(self.history) > 0:
            out = self.__record_create_time__(self.history[0])
                        
        return out
    
    def get_first_fixed_time(self):
        return self.__first_value_time__('Fixed')
    
    def get_first_qe_start_time(self):
        return self.__first_value_time__('QA In Progress')

    def get_last_fixed_time(self):
        return self.__last_value_time__('Fixed')
    
    def get_work_closed_time(self):
        return self.__last_value_time__('Closed')
    
    def get_count_of_times_set_to_status(self, status):
        out = []
        for record in self.history:
            if record['NewValue'] == status:
                if record['CreatedDate'] not in out:
                    out.append(record['CreatedDate'])
        return len(out)